procedure Tower(n, a, b: integer);
  (* Recursive procedure to print the optimal way to move
     n legally arranged disks from spike a to spike b. *)
  var third: integer;
  begin
    if n > 1
      then begin
             (* The indices of the three spikes sum to the constant 6. *)
             third := 6 - a - b;
             Tower(n-1,a,third);  (* Move the top n-1 disks out of the way. *)
             writeln('Move a disk from spike ',a:1,' to spike ',b:1);
             Tower(n-1,third,b)   (* Move the n-1 disks back. *)
           end
      else writeln('Move a disk from spike ',a:1,' to spike ',b:1)
  end; (* Tower *)
